local WPamA = WPamA
--local nvl = WPamA.SF_Nvl
--=========================================================================
--================= Endeavors Section =====================================
--=========================================================================
local EndeavorDailyConditions, EndeavorWeeklyConditions = {}, {}
local EndeavorChatMessageText = ""
local EndeavorChatFormatter = "<<1>>: <<2>> / <<3>>"
local GreenCondFormatter = "|c" .. WPamA.Colors.Mdl[6] .. "<<1>>|r"
local WhiteCondFormatter = "|c" .. WPamA.Colors.Mdl[4] .. "<<1>>: <<2>> / <<3>>|r"
local RewardTextFormatter = "<<1>><<2>>|t28:28:<<3>>|t "

function WPamA:UpdWindowModeEndeavor()
----  SV structure Endeavor : [1] | [2] = {NumCompl = 0, EndTS = 0, Reward = ""} -- Daily, Weekly
  local TS = GetTimeStamp()
  local f = self.SV_Main.LFGRndAvlFrmt
  local Endvr = self.SV_Main.Endeavor
  local strCompl = GetString(SI_QUEST_TYPE_COMPLETE)
  local RowCnt = 2
  for i = RowCnt + 1, self.Consts.RowCnt do
    self.ctrlRows[i].Row:SetHidden(true)
  end
  self:UI_UpdMainWindowSize(27, RowCnt)
--
  for i = 1, RowCnt do
    local r = self.ctrlRows[i]
    r.BG:SetHidden(true)
    r.Lvl:SetText(" ")
    r.Char:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
    r.Char:SetColor(self:GetColor(self.Colors.LabelLvl))
    self:SetScaledText(r.Char, self.i18n.EndeavorTypeNames[i])
--
    r.B[1]:SetColor(self:GetColor(self.Colors.LabelLvl))
    local endTS = Endvr[i].EndTS
    if endTS > 0 then
      local txt = ""
      if TS >= endTS then
        --r.B[1]:SetColor(self:GetColor(self.Colors.LabelLvl))
        txt = GetString(SI_GAMEPAD_STABLE_TRAINABLE_READY)
      elseif f == 1 then
        txt = self:DifTSToStr(endTS - TS, true, 0)
      elseif f == 2 then
        txt = self:TimestampToStr(endTS, 6, true)
      else
        txt = self:TimestampToStr(endTS, 7, true)
      end
      self:SetScaledText(r.B[1], txt)
    else -- data not exist
      r.B[1]:SetColor(self:GetColor(self.Colors.DungStNA)) -- gray
      r.B[1]:SetText(self.i18n.DungStNA)
    end
--
    r.B[2]:SetColor(self:GetColor(self.Colors.LabelLvl))
    local compl = Endvr[i].NumCompl
    local tooltip = ""
    if i == 1 then -- Daily
      if compl < 3 then r.B[2]:SetText(compl .. " / 3")
      else r.B[2]:SetText(strCompl)
      end
      if #EndeavorDailyConditions > 0 then
        for ind = 1, #EndeavorDailyConditions do
           tooltip = tooltip .. EndeavorDailyConditions[ind]
           if ind ~= #EndeavorDailyConditions then tooltip = tooltip .. "\n" end
        end
      end
    else -- Weekly
      if compl < 1 then r.B[2]:SetText(compl .. " / 1")
      else r.B[2]:SetText(strCompl)
      end
      if #EndeavorWeeklyConditions > 0 then
        for ind = 1, #EndeavorWeeklyConditions do
           tooltip = tooltip .. EndeavorWeeklyConditions[ind]
           if ind ~= #EndeavorWeeklyConditions then tooltip = tooltip .. "\n" end
        end
      end
    end
    self.SetTxtToolTip(r.B[2], tooltip)
--
    r.B[3]:SetColor(self:GetColor(self.Colors.LabelLvl))
    self:SetScaledText(r.B[3], Endvr[i].Reward)
--
    r.Row:SetHidden(false)
  end
end -- UpdWindowModeEndeavor end

local function GetEndeavorRewardString(index, numComplete)
  if not numComplete then numComplete = 0 end
  local RS = ""
  for ri = 1, GetNumTimedActivityRewards(index) do
    local RID, Q = GetTimedActivityRewardInfo(index, ri)
    local rewardData = REWARDS_MANAGER:GetInfoForReward(RID, Q)
    RS = zo_strformat(RewardTextFormatter, RS, numComplete * Q, rewardData.icon)
  end
  return RS
end -- GetEndeavorRewardString end

--[[
    --- RGB to Hex (for label/text color) ---
    rgb = (r * 0x10000) + (g * 0x100) + b
    string.format("%06x", rgb)
    string.format("%02x%02x%02x", r, g, b)
    --- Floats To Hex (for ColorPicker control) ---
    r, g, b, a = ZO_ColorDef.HexToFloats("RRGGBB") -- A = 1
    HexString = ZO_ColorDef.FloatsToHex(r, g, b, a)
--]]

function WPamA:EndeavorDataUpdate( taIndex )
  if not taIndex then taIndex = 0 end
  if taIndex > 0 then
    local taProgr = GetTimedActivityProgress(taIndex)
    local taMaxProgr = GetTimedActivityMaxProgress(taIndex)
    local taNm = GetTimedActivityName(taIndex)
    local taText = zo_strformat(EndeavorChatFormatter, taNm, taProgr, taMaxProgr)
    if taText == EndeavorChatMessageText then
      return
    else
      EndeavorChatMessageText = taText
      --- Show Endeavor's progress in chat ---
      local EPiC = self.SV_Main.EndeavorProgressInChat
      if EPiC.Enabled then
        if EPiC.isUseCustomColor then
          if EPiC.Color:len() < 6 then EPiC.Color = string.format("%02x%02x%02x", 238, 238, 200) end
          taText = zo_strformat("|c<<1>><<2>>|r", EPiC.Color, taText)
        end
        self:PostChatMessage(taText, EPiC.Channel)
      end
    end
  end
  local tinsert = table.insert
  local taDailyCompl, taWeeklyCompl = 0, 0
  local taDailyTime, taWeeklyTime = 0, 0
  local taDailyInd, taWeeklyInd = 0, 0
  local taDailyReward, taWeeklyReward = "", ""
  local taSV = self.SV_Main.Endeavor
  local taNum = GetNumTimedActivities()
  local TS = GetTimeStamp()
--- Init Condition's arrays ---
  EndeavorDailyConditions, EndeavorWeeklyConditions = {}, {}
--- Check Endeavor's statuses ---
  for i = 1, taNum do
    local taType = GetTimedActivityType(i)
    local taProgress = GetTimedActivityProgress(i)
    local taMaxProgress = GetTimedActivityMaxProgress(i)
    local taName = GetTimedActivityName(i)
    local txtCond = ""
    if taType == TIMED_ACTIVITY_TYPE_DAILY then -- Daily
      if taDailyTime == 0 then
        taDailyTime = GetTimedActivityTimeRemainingSeconds(i)
        taDailyInd = i
      end
      if taProgress >= taMaxProgress then
        taDailyCompl = taDailyCompl + 1
        txtCond = zo_strformat(GreenCondFormatter, taName)
      else
        txtCond = zo_strformat(WhiteCondFormatter, taName, taProgress, taMaxProgress)
      end
      tinsert(EndeavorDailyConditions, txtCond)
    else -- Weekly = TIMED_ACTIVITY_TYPE_WEEKLY
      if taWeeklyTime == 0 then
        taWeeklyTime = GetTimedActivityTimeRemainingSeconds(i)
        taWeeklyInd = i
      end
      if taProgress >= taMaxProgress then
        taWeeklyCompl = taWeeklyCompl + 1
        txtCond = zo_strformat(GreenCondFormatter, taName)
      else
        txtCond = zo_strformat(WhiteCondFormatter, taName, taProgress, taMaxProgress)
      end
      tinsert(EndeavorWeeklyConditions, txtCond)
    end
  end
--- Save statuses to SV ---
  local EndeavorMode = self.SV_Main.EndeavorRewardMode
  if EndeavorMode == 1 then -- single reward
    taDailyReward = GetEndeavorRewardString(taDailyInd, 1)
    taWeeklyReward = GetEndeavorRewardString(taWeeklyInd, 1)
  elseif EndeavorMode == 2 then -- current reward
    taDailyReward = GetEndeavorRewardString(taDailyInd, taDailyCompl)
    taWeeklyReward = GetEndeavorRewardString(taWeeklyInd, taWeeklyCompl)
  elseif EndeavorMode == 3 then -- max reward
    taDailyReward = GetEndeavorRewardString(taDailyInd, 3)
    taWeeklyReward = GetEndeavorRewardString(taWeeklyInd, 1)
  end
----  SV structure Endeavor : [1] | [2] = {NumCompl = 0, EndTS = 0, Reward = ""} -- Daily, Weekly
  taSV[1].NumCompl = taDailyCompl
  taSV[1].Reward = taDailyReward
  taSV[2].NumCompl = taWeeklyCompl
  taSV[2].Reward = taWeeklyReward
  if taDailyTime > 0 then taSV[1].EndTS = TS + taDailyTime end
  if taWeeklyTime > 0 then taSV[2].EndTS = TS + taWeeklyTime end
end -- EndeavorDataUpdate end

function WPamA.OnEndeavorUpdated(event, ... )
  local endvInd = ...
  WPamA:EndeavorDataUpdate( endvInd or 0 )
  local m = WPamA.SV_Main.ShowMode
  if m == 27 then WPamA:UpdWindowInfo() end -- endeavor update
  if event == EVENT_TIMED_ACTIVITIES_UPDATED then
    WPamA:UpdToday()
    local Modes = { [0] = true, [1] = true, [5] = true } -- calendar or hirelings mail update
    if Modes[m] then WPamA:UpdWindowInfo() end
  end
end -- OnEndeavorUpdated end
--=========================================================================
--================ Companions Section =====================================
--=========================================================================
local CompItemLinkFormatter = "|H1:item:<<1>>:1:0:0:0:0:0:0:0:0:0:0:0:1:0:0:1:0:0:0|h|h"

function WPamA:UpdWindowModeRapports(v, r)
  local wc = self.Companions
  local RapportColors = wc.RapportColors
  local RapportMode = self.SV_Main.CompanionRapportMode
  local isShowMaxRapport = self.SV_Main.CompanionRapportShowMax
--[[
wc =
  MaxRapport = GetMaximumRapport(),
  MinRapport = GetMinimumRapport(),
cc[companionId] = { Rapport = 99999, RapportLvl = 0, StoryQuests = {}, hasQuest = false }
--]]
  for i = 1, #wc.Persons do
    local txt = ""
    local cc = v.Companions[i]
    local locked = wc.Persons[i].isLocked or false
    local rapport = cc.Rapport
    local rapportLvl = cc.RapportLvl
    local story = cc.StoryQuests
    r.B[i]:SetColor(self:GetColor(self.Colors.LabelLvl))
    if locked then -- companion locked
      txt = self.Consts.IconsW.Lock
      r.B[i]:SetColor(self:GetColor(self.Colors.DungStNA))
    elseif cc.hasQuest then -- companion has a Intro quest
      txt = self.Consts.IconsW.Quest
    elseif rapport == 99999 then -- no data for companion
      txt = self.i18n.DungStNA
      r.B[i]:SetColor(self:GetColor(self.Colors.DungStNA))
    else  -- companion unlocked
      if RapportMode == 1 then -- as a number
        txt = rapport
        if isShowMaxRapport then
          if rapport >= 0 then txt = txt .. " / " .. wc.MaxRapport
          else txt = txt .. " / " .. wc.MinRapport
          end
        end
      else -- as a text
        txt = GetString("SI_COMPANIONRAPPORTLEVEL", rapportLvl)
      end
      txt = zo_strformat(RapportColors[rapportLvl], txt)
      --- companion has a Story quest ---
      if story[1] and (rapportLvl > RAPPORT_LEVEL_SLIGHT_AFFINITY) then
        txt = self.Consts.IconsW.Quest .. txt
      elseif story[2] and (rapportLvl > RAPPORT_LEVEL_MODERATE_AFFINITY) then
        txt = self.Consts.IconsW.Quest .. txt
      elseif story[3] and (rapportLvl > RAPPORT_LEVEL_HIGH_AFFINITY) then
        txt = self.Consts.IconsW.Quest .. txt
      end
    end
    self:SetScaledText(r.B[i], txt)
  end
end -- UpdWindowModeRapports end

function WPamA:UpdWindowModeCompClassSkills()
  local WCP = self.Companions.Persons
  local WCID = self.Companions.ActiveCompanionId
--WCP: { IID = IngameCompanionId, CID = CollectibleId, Name = "CompanionName", QID = QuestId, isLocked = lockedStatus }
  local ACC = self.SV_Main.Companions
--ACC = { Lvl = 99, LvlPrc = 0, Skills = { [ind] = {Lvl = 1, LvlPrc = 0, isLocked = true} }, }
  local RowCnt = #WCP
  for i = RowCnt + 1, self.Consts.RowCnt do
    self.ctrlRows[i].Row:SetHidden(true)
  end
  self:UI_UpdMainWindowSize(32, RowCnt)
--
  for i = 1, RowCnt do
    local r = self.ctrlRows[i]
    r.BG:SetHidden( WCID ~= i )
    r.Lvl:SetColor(self:GetColor(self.Colors.LabelLvl))
    if ACC[i].Lvl < 50 then r.Lvl:SetText(ACC[i].Lvl)
    else r.Lvl:SetText(0)
    end
    r.Char:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
    r.Char:SetColor(self:GetColor(self.Colors.LabelLvl))
    self:SetScaledText(r.Char, WCP[i].Name)
--
    for j = 1, 7 do
      local txt = " "
      local skills = ACC[i].Skills[j + 2] -- show skills from 3 to 9 of SkillLines array
      -- skills = {Lvl = 1, LvlPrc = 0, isLocked = true}
      local maxRank = self.Companions.SkillLines[j + 2].Max or 20
      r.B[j]:SetColor(self:GetColor(self.Colors.LabelLvl))
      if skills then
        local locked = WCP[i].isLocked or skills.isLocked or false
        if locked then -- companion or skill-line is locked
          r.B[j]:SetColor(self:GetColor(self.Colors.DungStNA)) -- gray
          txt = self.Consts.IconsW.Lock
        else
          if skills.Lvl >= maxRank then
            r.B[j]:SetColor(self:GetColor(self.Colors.DungStDone)) -- green
          end
          txt = skills.Lvl + skills.LvlPrc
        end
      else -- data not exist
        r.B[j]:SetColor(self:GetColor(self.Colors.DungStNA)) -- gray
        txt = self.i18n.DungStNA
      end
      self:SetScaledText(r.B[j], txt)
    end
--
    r.Row:SetHidden(false)
  end
end -- UpdWindowModeCompClassSkills end

function WPamA:UpdWindowModeCompWeaponSkills()
  local WCP = self.Companions.Persons
  local WCID = self.Companions.ActiveCompanionId
--WCP: { IID = IngameCompanionId, CID = CollectibleId, Name = "CompanionName", QID = QuestId, isLocked = lockedStatus }
  local ACC = self.SV_Main.Companions
--ACC = { Lvl = 99, LvlPrc = 0, Skills = { [ind] = {Lvl = 1, LvlPrc = 0, isLocked = true} }, }
  local RowCnt = #WCP
  for i = RowCnt + 1, self.Consts.RowCnt do
    self.ctrlRows[i].Row:SetHidden(true)
  end
  self:UI_UpdMainWindowSize(36, RowCnt)
--
  for i = 1, RowCnt do
    local r = self.ctrlRows[i]
    r.BG:SetHidden( WCID ~= i )
    r.Lvl:SetColor(self:GetColor(self.Colors.LabelLvl))
    if ACC[i].Lvl < 50 then r.Lvl:SetText(ACC[i].Lvl)
    else r.Lvl:SetText(0)
    end
    r.Char:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
    r.Char:SetColor(self:GetColor(self.Colors.LabelLvl))
    self:SetScaledText(r.Char, WCP[i].Name)
--
    for j = 1, 6 do
      local txt = " "
      local skills = ACC[i].Skills[j + 9] -- show skills from 10 to 15 of SkillLines array
      -- skills = {Lvl = 1, LvlPrc = 0, isLocked = true}
      local maxRank = self.Companions.SkillLines[j + 9].Max or 20
      r.B[j]:SetColor(self:GetColor(self.Colors.LabelLvl))
      if skills then
        local locked = WCP[i].isLocked or skills.isLocked or false
        if locked then -- companion or skill-line is locked
          r.B[j]:SetColor(self:GetColor(self.Colors.DungStNA)) -- gray
          txt = self.Consts.IconsW.Lock
        else
          if skills.Lvl >= maxRank then
            r.B[j]:SetColor(self:GetColor(self.Colors.DungStDone)) -- green
          end
          txt = skills.Lvl + skills.LvlPrc
        end
      else -- data not exist
        r.B[j]:SetColor(self:GetColor(self.Colors.DungStNA)) -- gray
        txt = self.i18n.DungStNA
      end
      self:SetScaledText(r.B[j], txt)
    end
--
    r.Row:SetHidden(false)
  end
end -- UpdWindowModeCompWeaponSkills end

local function GetItemLinkByItemData(ItemDataString)
  if type(ItemDataString) == "string" then
    return zo_strformat(CompItemLinkFormatter, ItemDataString)
  end
  return ""
end -- GetItemLinkByItemData end

function WPamA:UpdWindowModeCompArmorEquips()
  local EquipMode = self.SV_Main.CompanionEquipMode
  local Lng = self.i18n.Lng
  local EquipReplace = self.i18n.CompanionEquipRepl
  local EquipSubs = self.Companions.EquipNameSubs
  local WCP = self.Companions.Persons
  local WCID = self.Companions.ActiveCompanionId
--WCP: { IID = IngameCompanionId, CID = CollectibleId, Name = "CompanionName", QID = QuestId, isLocked = lockedStatus }
  local ACC = self.SV_Main.Companions
--ACC = { Lvl = 99, LvlPrc = 0, Skills = {}, Equips = {[1]..[12] = "item link data"} }
  local RowCnt = #WCP
  for i = RowCnt + 1, self.Consts.RowCnt do
    self.ctrlRows[i].Row:SetHidden(true)
  end
  self:UI_UpdMainWindowSize(39, RowCnt)
--
  for i = 1, RowCnt do
    local r = self.ctrlRows[i]
    r.BG:SetHidden( WCID ~= i )
    r.Lvl:SetColor(self:GetColor(self.Colors.LabelLvl))
    if ACC[i].Lvl < 50 then r.Lvl:SetText(ACC[i].Lvl)
    else r.Lvl:SetText(0)
    end
    r.Char:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
    r.Char:SetColor(self:GetColor(self.Colors.LabelLvl))
    self:SetScaledText(r.Char, WCP[i].Name)
--
    for j = 1, 7 do
      local txt = " "
      local equip = ACC[i].Equips[j] -- show equips from 1 to 7 of EquipSlots array
      ---- equips = { [1]..[12] = "item link data" }
      r.B[j]:SetColor(self:GetColor(self.Colors.LabelLvl))
      if equip then
        if equip == "" then -- empty equip slot
          r.B[j]:SetColor(self:GetColor(self.Colors.DungStNA)) -- gray
          txt = "-"
        else
          local itemLink = GetItemLinkByItemData(equip)
          if itemLink ~= "" then
            if EquipMode == 1 then -- show item name
              txt = zo_strformat( SI_COMPANION_NAME_FORMATTER, GetItemLinkName(itemLink) )
              if EquipReplace.CompTitle then
                txt = txt:gsub( EquipReplace.CompTitle, "" )
              end
              if EquipReplace[txt] and EquipReplace[txt][EquipMode] then
                txt = EquipReplace[txt][EquipMode]
              end

            elseif EquipMode == 2 then -- show item type
              local armorType = GetItemLinkArmorType(itemLink)
              txt = GetString( SI_ARMORTYPE1 + 2 * (armorType - 1) ):gsub("%s.+", "")

            elseif EquipMode == 3 then -- show item trait
              local traitType = GetItemLinkTraitInfo(itemLink)
              txt = GetString( SI_ITEMTRAITTYPE0 + traitType )
              if EquipReplace[txt] and EquipReplace[txt][EquipMode] then
                txt = EquipReplace[txt][EquipMode]
              end

            else -- show type + trait
              local armorType = GetItemLinkArmorType(itemLink)
              txt = GetString( SI_ARMORTYPE1 + 2 * (armorType - 1) )
              txt = txt:sub(1, EquipSubs[Lng] or 2)
              local traitType = GetItemLinkTraitInfo(itemLink)
              local traitName = GetString( SI_ITEMTRAITTYPE0 + traitType )
              if EquipReplace[traitName] and EquipReplace[traitName][EquipMode] then
                traitName = EquipReplace[traitName][EquipMode]
              end
              txt = txt .. " - " .. traitName
            end
            local itemQuality = GetItemLinkDisplayQuality(itemLink)
            local qualityColor = GetItemQualityColor(itemQuality)
            txt = qualityColor:Colorize(txt)
            self.SetItemToolTip(r.B[j], itemLink)
          end
        end
      else -- data not exist
        r.B[j]:SetColor(self:GetColor(self.Colors.DungStNA)) -- gray
        txt = self.i18n.DungStNA
      end
      self:SetScaledText(r.B[j], txt)
    end
--
    r.Row:SetHidden(false)
  end
end -- UpdWindowModeCompArmorEquips end

local function GetWeaponTypeByItemLink(itemLink)
  local OneHandedTypes = {
    [WEAPONTYPE_AXE] = true,
    [WEAPONTYPE_DAGGER] = true,
    [WEAPONTYPE_SHIELD] = true,
    [WEAPONTYPE_SWORD] = true,
    [WEAPONTYPE_HAMMER] = true,
  }
  local TwoHandedTypes = {
    [WEAPONTYPE_BOW] = true,
    [WEAPONTYPE_FIRE_STAFF] = true,
    [WEAPONTYPE_FROST_STAFF] = true,
    [WEAPONTYPE_HEALING_STAFF] = true,
    [WEAPONTYPE_LIGHTNING_STAFF] = true,
    [WEAPONTYPE_TWO_HANDED_AXE] = true,
    [WEAPONTYPE_TWO_HANDED_HAMMER] = true,
    [WEAPONTYPE_TWO_HANDED_SWORD] = true,
  }
--WEAPONTYPE_NONE
--WEAPONTYPE_RUNE
  if itemLink and (itemLink ~= "") then
    local WT = GetItemLinkWeaponType(itemLink)
    if OneHandedTypes[WT] then
      return WEAPON_CONFIG_TYPE_ONE_HANDED -- = 10
    elseif TwoHandedTypes[WT] then
      return WEAPON_CONFIG_TYPE_TWO_HANDED -- = 3
    end
  end
  return WEAPON_CONFIG_TYPE_NONE -- = 0
end -- GetWeaponTypeByItemLink end

function WPamA:UpdWindowModeCompWeaponEquips()
  local EquipMode = self.SV_Main.CompanionEquipMode
  local Lng = self.i18n.Lng
  local EquipReplace = self.i18n.CompanionEquipRepl
  local EquipSubs = self.Companions.EquipNameSubs
  local WCP = self.Companions.Persons
  local WCID = self.Companions.ActiveCompanionId
--WCP: { IID = IngameCompanionId, CID = CollectibleId, Name = "CompanionName", QID = QuestId, isLocked = lockedStatus }
  local ACC = self.SV_Main.Companions
--ACC = { Lvl = 99, LvlPrc = 0, Skills = {}, Equips = {[1]..[12] = "item link data"} }
  local RowCnt = #WCP
  for i = RowCnt + 1, self.Consts.RowCnt do
    self.ctrlRows[i].Row:SetHidden(true)
  end
  self:UI_UpdMainWindowSize(40, RowCnt)
--
  for i = 1, RowCnt do
    local r = self.ctrlRows[i]
    r.BG:SetHidden( WCID ~= i )
    r.Lvl:SetColor(self:GetColor(self.Colors.LabelLvl))
    if ACC[i].Lvl < 50 then r.Lvl:SetText(ACC[i].Lvl)
    else r.Lvl:SetText(0)
    end
    r.Char:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
    r.Char:SetColor(self:GetColor(self.Colors.LabelLvl))
    self:SetScaledText(r.Char, WCP[i].Name)
--
    local has2HWeapon = false
    local eq = ACC[i].Equips[8] or ""
    if eq ~= "" then -- weapon is in inventory
      local wt = GetWeaponTypeByItemLink( GetItemLinkByItemData(eq) )
      if wt == WEAPON_CONFIG_TYPE_TWO_HANDED then has2HWeapon = true end
    end
--
    for j = 1, 5 do
      local txt = " "
      local equip = ACC[i].Equips[j + 7] -- show equips from 8 to 12 of EquipSlots array
      ---- equips = { [1]..[12] = "item link data" }
      if (j == 2) and has2HWeapon then equip = ACC[i].Equips[8] end
      r.B[j]:SetColor(self:GetColor(self.Colors.LabelLvl))
      if equip then
        if equip == "" then -- empty equip slot
          r.B[j]:SetColor(self:GetColor(self.Colors.DungStNA)) -- gray
          txt = "-"
        else
          local itemLink = GetItemLinkByItemData(equip)
          if itemLink ~= "" then
            if EquipMode == 1 then -- show item name
              txt = zo_strformat( SI_COMPANION_NAME_FORMATTER, GetItemLinkName(itemLink) )
              if EquipReplace.CompTitle then
                txt = txt:gsub( EquipReplace.CompTitle, "" )
              end
              if EquipReplace[txt] and EquipReplace[txt][EquipMode] then
                txt = EquipReplace[txt][EquipMode]
              end

            elseif EquipMode == 2 then -- show item type
              if j < 3 then -- weapon
                local armorType = SI_EQUIPTYPE5 -- One-Handed by default
                if has2HWeapon then armorType = SI_EQUIPTYPE6 end -- Two-Handed
                if EquipReplace[armorType] and EquipReplace[armorType][EquipMode] then
                  txt = EquipReplace[armorType][EquipMode]
                else
                  txt = GetString(armorType)
                end
              elseif j == 3 then -- necklace
                txt = zo_strformat( SI_COMPANION_NAME_FORMATTER, GetString(SI_EQUIPSLOT1):gsub("%s.+", "") )
              elseif j > 3 then -- ring
                if EquipReplace[SI_EQUIPSLOT11] and EquipReplace[SI_EQUIPSLOT11][EquipMode] then
                  txt = EquipReplace[SI_EQUIPSLOT11][EquipMode]
                else
                  txt = zo_strformat( SI_COMPANION_NAME_FORMATTER, GetString(SI_EQUIPSLOT11):gsub("%s.+", "") )
                end
              end

            elseif EquipMode == 3 then -- show item trait
              local traitType = GetItemLinkTraitInfo(itemLink)
              txt = GetString( SI_ITEMTRAITTYPE0 + traitType )
              if EquipReplace[txt] and EquipReplace[txt][EquipMode] then
                txt = EquipReplace[txt][EquipMode]
              end

            else -- show type + trait
              if j < 3 then -- weapon
                local armorType = SI_EQUIPTYPE5 -- One-Handed by default
                if has2HWeapon then armorType = SI_EQUIPTYPE6 end -- Two-Handed
                if EquipReplace[armorType] and EquipReplace[armorType][EquipMode] then
                  txt = EquipReplace[armorType][EquipMode]
                else
                  txt = GetString(armorType)
                end
              elseif j == 3 then -- necklace
                txt = GetString(SI_EQUIPTYPE2):sub(1, EquipSubs[Lng] or 2)
              elseif j > 3 then -- ring
                txt = GetString(SI_EQUIPTYPE12):sub(1, EquipSubs[Lng] or 2)
              end
              local traitType = GetItemLinkTraitInfo(itemLink)
              local traitName = GetString( SI_ITEMTRAITTYPE0 + traitType )
              if EquipReplace[traitName] and EquipReplace[traitName][EquipMode] then
                traitName = EquipReplace[traitName][EquipMode]
              end
              txt = txt .. " - " .. traitName
            end

            if (j == 2) and has2HWeapon then
              r.B[j]:SetColor(self:GetColor(self.Colors.DungStNA)) -- gray
              self.SetItemToolTip(r.B[j])
            else
              local itemQuality = GetItemLinkDisplayQuality(itemLink)
              local qualityColor = GetItemQualityColor(itemQuality)
              txt = qualityColor:Colorize(txt)
              self.SetItemToolTip(r.B[j], itemLink)
            end
          end
        end
      else -- data not exist
        r.B[j]:SetColor(self:GetColor(self.Colors.DungStNA)) -- gray
        txt = self.i18n.DungStNA
      end
      self:SetScaledText(r.B[j], txt)
    end
--
    r.Row:SetHidden(false)
  end
end -- UpdWindowModeCompWeaponEquips end

--[[
GetItemLinkArmorType(*string* _itemLink_)
Returns: *[ArmorType|#ArmorType]* _armorType_

ARMORTYPE_NONE
ARMORTYPE_LIGHT
ARMORTYPE_MEDIUM
ARMORTYPE_HEAVY
txt = GetString( SI_ARMORTYPE?? ):gsub("%s.+", "")
SI_ARMORTYPE0 = "None"
SI_ARMORTYPE1 = "Light"
SI_ARMORTYPE2 = "Medium"
SI_ARMORTYPE3 = "Heavy"

txt = GetString( SI_WEAPONTYPE?? ):gsub("%s.+", "")
SI_WEAPONTYPE0, "do not translate", 0)
SI_WEAPONTYPE1, "Axe", 0)
SI_WEAPONTYPE2, "Mace", 0)
SI_WEAPONTYPE3, "Sword", 0)
SI_WEAPONTYPE4, "Sword", 0)
SI_WEAPONTYPE5, "Axe", 0)
SI_WEAPONTYPE6, "Mace", 0)
SI_WEAPONTYPE7, "do not translate", 0)
SI_WEAPONTYPE8, "Bow", 0)
SI_WEAPONTYPE9, "Healing Staff", 0)
SI_WEAPONTYPE10, "Rune", 0)
SI_WEAPONTYPE11, "Dagger", 0)
SI_WEAPONTYPE12, "Flame Staff", 0)
SI_WEAPONTYPE13, "Frost Staff", 0)
SI_WEAPONTYPE14, "Shield", 0)
SI_WEAPONTYPE15, "Lightning Staff", 0)

GetItemLinkWeaponType(*string* _itemLink_)
Returns: *[WeaponType|#WeaponType]* _weaponType_

WEAPONTYPE_AXE
WEAPONTYPE_BOW
WEAPONTYPE_DAGGER
WEAPONTYPE_FIRE_STAFF
WEAPONTYPE_FROST_STAFF
WEAPONTYPE_HAMMER
WEAPONTYPE_HEALING_STAFF = 9
WEAPONTYPE_LIGHTNING_STAFF
WEAPONTYPE_NONE
WEAPONTYPE_RUNE
WEAPONTYPE_SHIELD
WEAPONTYPE_SWORD
WEAPONTYPE_TWO_HANDED_AXE
WEAPONTYPE_TWO_HANDED_HAMMER
WEAPONTYPE_TWO_HANDED_SWORD

GetItemLinkTraitInfo(string itemLink)
Returns: number ItemTraitType traitType, string traitDescription
 from SI_ITEMTRAITTYPE0 to SI_ITEMTRAITTYPE60
 ITEM_TRAIT_TYPE_ARMOR_AGGRESSIVE = 47
 SI_ITEMTRAITTYPE38 = "Aggressive"
 SI_ITEMTRAITTYPE47 = "Aggressive"
 d( GetString(SI_ITEMTRAITTYPE0 + 47) )
   local itemIcon = GetItemLinkInfo(itemLink)
   itemIcon = "|t24:24:" .. itemIcon .. "|t"

ItemDisplayQuality
ITEM_DISPLAY_QUALITY_ARCANE
ITEM_DISPLAY_QUALITY_ARTIFACT
ITEM_DISPLAY_QUALITY_LEGENDARY
ITEM_DISPLAY_QUALITY_MAGIC
ITEM_DISPLAY_QUALITY_MYTHIC_OVERRIDE
ITEM_DISPLAY_QUALITY_NORMAL
ITEM_DISPLAY_QUALITY_TRASH
--]]

function WPamA:UpdateCompanionStoryQuests(ccid)
  local WCP = self.Companions.Persons
  local CCC = self.CurChar.Companions
  local SQ = WCP[ccid].SQ
  local CSQ = CCC[ccid].StoryQuests
  for sid = 1, #SQ do
    local qn = GetCompletedQuestInfo( SQ[sid] )
    CSQ[sid] = ( qn == "" )
  end
end -- UpdateCompanionStoryQuests end

function WPamA:SetCompanionsPersons()
  local WCP = self.Companions.Persons
  local HDT = self.ModeSettings[29].HdT
--WCP: { IID = IngameCompanionId, DLC = CollectibleId, Name = "CompanionName", QID = QuestId, isLocked = lockedStatus }
  for ccid = 1, #WCP do
    local companionId = WCP[ccid].IID
    local companionName = zo_strformat( SI_COMPANION_NAME_FORMATTER, GetCompanionName(companionId) )
    if companionName ~= "" then
      WCP[ccid].Name = companionName
      if ccid == 5 then -- Sharp-As-Night
        HDT[ccid] = companionName:gsub("-.+", "")
      else
        HDT[ccid] = companionName:gsub("%s.+", "")
      end
    end
  end
end -- SetCompanionsPersons end

function WPamA:CheckCompanionsUnlocked()
  local WCP = self.Companions.Persons
  local CCC = self.CurChar.Companions
--WCP: { IID = IngameCompanionId, CID = CollectibleId, Name = "CompanionName", QID = QuestId, isLocked = lockedStatus }
  for ccid = 1, #WCP do
    WCP[ccid].isLocked = not IsCollectibleUnlocked( WCP[ccid].DLC )
    local qn = GetCompletedQuestInfo( WCP[ccid].QID )
    CCC[ccid].hasQuest = ( qn == "" )
  end
end -- CheckCompanionsUnlocked end

local function GetCompanionLevelProgress(level, currentExperience)
  local expPerc = 0
  local expLvl = GetNumExperiencePointsInCompanionLevel(level + 1)
  if expLvl and (expLvl > 0) then expPerc = math.floor(100 * currentExperience / expLvl) / 100 end
  return expPerc
end -- GetCompanionLevelProgress end

local function GetCompanionSkillLineProgress(SkillLineID)
  local sid = WPamA.Companions.Iterators.SL[SkillLineID]
  if not sid then
    return 1, 0, true
  end
  local maxRank = WPamA.Companions.SkillLines[sid].Max or 20
  local SkillLineRank, _, isSkillLineDiscovered = GetCompanionSkillLineDynamicInfo(SkillLineID)
  if SkillLineRank < 1 then SkillLineRank = 1 end
  local xpPrc = 0
  if SkillLineRank < maxRank then
    local LastLineRankXP, NextLineRankXP, CurrentLineRankXP = GetCompanionSkillLineXPInfo(SkillLineID)
    local currLineXP = CurrentLineRankXP - LastLineRankXP
    local nextLineXP = NextLineRankXP - LastLineRankXP
    if nextLineXP > 0 then
      xpPrc = math.floor(100 * currLineXP / nextLineXP) / 100
    end
  end
  return SkillLineRank, xpPrc, (not isSkillLineDiscovered)
end -- GetCompanionSkillLineProgress end

local function GetItemDataFromLink(ItemLinkString)
  if type(ItemLinkString) == "string" then
    local tblDiv = {}
    string.gsub( ItemLinkString, ":(%d+)", function(s) table.insert(tblDiv, s) end )
    ---- string.gsub("|H1:item:175812:429:1:0:0:0:0:0:0:0:0:0:0:0:1:0:0:1:0:0:0|h|h", ":(%d+)", function(s) d(s) end)
    if tblDiv[1] and tblDiv[2] then return tblDiv[1] .. ":" .. tblDiv[2] end
  end
  return ""
end -- GetItemDataFromLink end

function WPamA:UpdActiveCompanionData(companionId)
  if not HasActiveCompanion() then return end
  if companionId == nil then companionId = GetActiveCompanionDefId() end
  local ccid = self.Companions.Iterators.I[companionId]
  if not ccid then return end
  self.Companions.ActiveCompanionId = ccid
  local WCP = self.Companions.Persons
  local ACC = self.SV_Main.Companions
  local CCC = self.CurChar.Companions
  local CSL = self.Companions.SkillLines
  local CES = self.Companions.EquipSlots
--[[
WCP = { IID = IngameCompanionId, CID = CollectibleId, Name = "CompanionName", QID = QuestId, isLocked = lockedStatus }
CCC = { Rapport = 0, RapportLvl = 1, hasQuest = false, }
ACC = { Lvl = 99, LvlPrc = 0, Skills = { [ind] = {Lvl = 1, LvlPrc = 0, isLocked = true} }, }
--]]
  if WCP[ccid].isLocked then WCP[ccid].isLocked = false end
  if CCC[ccid].hasQuest then CCC[ccid].hasQuest = false end
  if not ACC[ccid].LvlPrc then ACC[ccid].LvlPrc = 0 end
  if not ACC[ccid].Skills then ACC[ccid].Skills = {} end
  if not ACC[ccid].Equips then ACC[ccid].Equips = {} end
--
  local curRapport = GetActiveCompanionRapport()
  CCC[ccid].Rapport = curRapport
  local lvlRapport = GetActiveCompanionRapportLevel()
  CCC[ccid].RapportLvl = lvlRapport
  self:UpdateCompanionStoryQuests(ccid)
--
  local level, curExp = GetActiveCompanionLevelInfo()
  if (level > 0) and (curExp >= 0) then
    ACC[ccid].Lvl = level
    ACC[ccid].LvlPrc = GetCompanionLevelProgress(level, curExp)
  end
-- update Equip Slots --
  local equip = ACC[ccid].Equips
  for i = 1, #CES do
    local slotId = CES[i]
    local slotHasItem = GetWornItemInfo(BAG_COMPANION_WORN, slotId)
    if slotHasItem then
      --- slot has item ---
      local itemLink = GetItemLink(BAG_COMPANION_WORN, slotId, LINK_STYLE_DEFAULT)
      local itemData = GetItemDataFromLink(itemLink)
      if itemData ~= "" then
        equip[i] = itemData
      end
    else
      --- slot has no item ---
      equip[i] = ""
    end
  end
-- update Skill Lines --
  local sid, sln = 0, ACC[ccid].Skills
  for i = 1, #CSL do
    if i < 4 then sid = CSL[i].CID[ccid]
    else sid = CSL[i].ID
    end
    CSL[i].Name = GetCompanionSkillLineNameById(sid) or "???"
    if not sln[i] then sln[i] = {Lvl = 1, LvlPrc = 0, isLocked = true} end
    sln[i].Lvl, sln[i].LvlPrc, sln[i].isLocked = GetCompanionSkillLineProgress(sid)
  end
end -- UpdActiveCompanionData end

function WPamA.OnCompanionActivated(event, companionId)
  WPamA:UpdActiveCompanionData(companionId)
  local m = WPamA.SV_Main.ShowMode
  local Modes = { [29] = true, [32] = true, [36] = true, [39] = true, [40] = true }
  if Modes[m] then WPamA:UpdWindowInfo() end
end -- OnCompanionActivated end

function WPamA.OnCompanionDeactivated(event)
  WPamA.Companions.ActiveCompanionId = 0
  local m = WPamA.SV_Main.ShowMode
  local Modes = { [32] = true, [36] = true, [39] = true, [40] = true }
  if Modes[m] then WPamA:UpdWindowInfo() end
end -- OnCompanionDeactivated end

function WPamA.OnCompanionRapportUpdate(event, companionId, previousRapport, currentRapport, adjustmentAmountType)
--EVENT_COMPANION_RAPPORT_UPDATE (integer companionId, integer previousRapport, integer currentRapport, CompanionRapportAdjustmentAmount adjustmentAmountType)
  local ccid = WPamA.Companions.Iterators.I[companionId]
  if not ccid then return end
  local CCC = WPamA.CurChar.Companions
  CCC[ccid].Rapport = currentRapport
  local oldLvl = CCC[ccid].RapportLvl
  local levelRapport = GetActiveCompanionRapportLevel()
  CCC[ccid].RapportLvl = levelRapport
  if oldLvl ~= levelRapport then WPamA:UpdateCompanionStoryQuests(ccid) end
--
  local m = WPamA.SV_Main.ShowMode
  if m == 29 then WPamA:UpdWindowInfo() end
end -- OnCompanionRapportUpdate end

function WPamA.OnCompanionExpGain(event, companionId, level, previousExperience, currentExperience)
--EVENT_COMPANION_EXPERIENCE_GAIN (*integer* _companionId_, *integer* _level_, *integer* _previousExperience_, *integer* _currentExperience_)
  local ccid = WPamA.Companions.Iterators.I[companionId]
  if not ccid then return end
  local ACC = WPamA.SV_Main.Companions -- ACC = { Lvl = 99, LvlPrc = 0, Skills = { [ind] = {Lvl = 1, LvlPrc = 0, isLocked = true} }, }
  local oldLvl = ACC[ccid].Lvl
  if (level > 0) and (currentExperience > 0) then
    ACC[ccid].Lvl = level
    ACC[ccid].LvlPrc = GetCompanionLevelProgress(level, currentExperience)
  end
--
  local m = WPamA.SV_Main.ShowMode
  local Modes = { [29] = true, [32] = true, [36] = true, [39] = true, [40] = true }
  if (m == 32) or ( Modes[m] and (oldLvl ~= ACC[ccid].Lvl) ) then WPamA:UpdWindowInfo() end
end -- OnCompanionExpGain end

function WPamA.OnCompanionSkillLineUpdate(event, skillLineId, ...)
--EVENT_COMPANION_SKILL_LINE_ADDED (*integer* _skillLineId_)
--EVENT_COMPANION_SKILL_RANK_UPDATE (*integer* _skillLineId_, *luaindex* _rank_)
--EVENT_COMPANION_SKILL_XP_UPDATE (*integer* _skillLineId_, *integer* _reason_, *luaindex* _rank_, *integer* _previousXP_, *integer* _currentXP_)
  local sid = WPamA.Companions.Iterators.SL[skillLineId]
  if not sid then return end
  local companionId = GetActiveCompanionDefId()
  local ccid = WPamA.Companions.Iterators.I[companionId]
  if not ccid then return end
--
  local ACC = WPamA.SV_Main.Companions -- ACC = { Lvl = 99, LvlPrc = 0, Skills = {}, Equips = {} }
  local sln = ACC[ccid].Skills[sid] -- Skills = { [ind] = {Lvl = 1, LvlPrc = 0, isLocked = true} }
  if not sln then sln = {Lvl = 1, LvlPrc = 0, isLocked = true} end
--
  sln.Lvl, sln.LvlPrc, sln.isLocked = GetCompanionSkillLineProgress(skillLineId)
  if (sid < 4) and (ACC[ccid].Lvl < sln.Lvl) then -- just for rare cases of delayed event
    ACC[ccid].Lvl = sln.Lvl
    ACC[ccid].LvlPrc = sln.LvlPrc
  end
--
  local m = WPamA.SV_Main.ShowMode
  if (m == 32) or (m == 36) then WPamA:UpdWindowInfo() end
end -- OnCompanionSkillLineUpdate end

function WPamA.OnCompanionEquipSlotUpdate(event, bagId, slotId, ... )
--EVENT_INVENTORY_SINGLE_SLOT_UPDATE (*Bag* _bagId_, *integer* _slotIndex_, *bool* _isNewItem_, ...)
  if bagId ~= BAG_COMPANION_WORN then return end
  local sid = WPamA.Companions.Iterators.ES[slotId]
  if not sid then return end
  local companionId = GetActiveCompanionDefId()
  local ccid = WPamA.Companions.Iterators.I[companionId]
  if not ccid then return end
--
  local ACC = WPamA.SV_Main.Companions -- ACC = { Lvl = 99, LvlPrc = 0, Skills = {}, Equips = {} }
  if not ACC[ccid].Equips then ACC[ccid].Equips = {} end
  if not ACC[ccid].Equips[sid] then ACC[ccid].Equips[sid] = "" end
--
  local slotHasItem = GetWornItemInfo(bagId, slotId)
  if slotHasItem then
    --- item of equipment worn ---
    local itemLink = GetItemLink(bagId, slotId, LINK_STYLE_DEFAULT)
    local itemData = GetItemDataFromLink(itemLink)
    if itemData ~= "" then
      ACC[ccid].Equips[sid] = itemData
    end
  else
    --- item of equipment removed ---
    ACC[ccid].Equips[sid] = ""
  end
--
  local m = WPamA.SV_Main.ShowMode
  if (m == 39) or (m == 40) then WPamA:UpdWindowInfo() end
end -- OnCompanionEquipSlotUpdate end
