---о-UTF8-о---
local WPamA = WPamA
--
local function nvl(a, b) if a ~= nil then return a elseif b ~= nil then return b else return "nil" end end
local function nvlb(val) if val == nil then return "Nil" elseif val then return "True" end return "False" end
--
local SortedWorldEventsIndex = {}
local CurrentWorldEvents = {}
--=========================================================================
--=============== World events data-base Section ==========================
--=========================================================================
-- POI : [PoiInd] = { ID = POI Index, Name = POI name, isActive = false, EndTS = Event end's TS }
-- Structure : [ZoneId] = { PZI = Map Zone Index, ZoneName = Zone Name, POI | Units = {}, WEContext = context }
-- WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST | WORLD_EVENT_LOCATION_CONTEXT_UNIT | WORLD_EVENT_LOCATION_CONTEXT_NONE
--[[
  EventType :
    WORLD_EVENT_TYPE_MONSTER_HUNT = 0	WORLD_EVENT_TYPE_HARROWSTORM = 1
    WORLD_EVENT_TYPE_DARK_ANCHOR = 2	WORLD_EVENT_TYPE_GEYSER = 3
    WORLD_EVENT_TYPE_FISSURE = 4	WORLD_EVENT_TYPE_MIRRORMOOR = 5
--]]
local WorldEvents = {
  isPlayerActive = false,
  CurrentZoneId = 0,
  CurrentActivePOI = { POI = 0, StartTS = 0 },
  AverageTimeBetweenPOI = 0,
  UNITBuffs = { [122559] = true, [122561] = true, [122562] = true },
  -- Buff 122562 [Storm Dragon] | 122561 [Frost Dragon] | 122559 [Flame Dragon]
  UNITEvents = {
    [1086] = { PZI = 681, -- PoiZoneIndex "Northern Elsweyr"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_UNIT,
               EventType = WORLD_EVENT_TYPE_MONSTER_HUNT,
               RespTimeDelta = 600,
               -- 1 South dragon | 2 North dragon | 3 West dragon
               UNIT = { 1, 2, 3 },
               UnitPos = { [1] = "S", [2] = "N", [3] = "W" },
             },
    [1133] = { PZI = 720, -- PoiZoneIndex "Southern Elsweyr"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_UNIT,
               EventType = WORLD_EVENT_TYPE_MONSTER_HUNT,
               RespTimeDelta = 120,
               -- 12 North dragon | 13 South dragon
               UNIT = { 12, 13 },
               UnitPos = { [12] = "N", [13] = "S" },
             },
  }, -- UNITEvents array
  POIEvents = {
               -- PZI = PoiZoneIndex = MapZoneIndex
    [   3] = { PZI = 2, -- PoiZoneIndex "Glenumbra"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 43, 44, 45 },
--              PinIcon = "|t24:24:/esoui/art/icons/poi/poi_portal_complete.dds|t",
--              PinType = 40,
             },
------------
    [  19] = { PZI = 4, -- PoiZoneIndex "Stormhaven"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 39, 40, 41 },
             },
------------
    [  20] = { PZI = 5, -- PoiZoneIndex "Rivenspire"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 38, 39, 40 },
             },
------------
    [  41] = { PZI = 9, -- PoiZoneIndex "Stonefalls"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 43, 44, 45 },
             },
------------
    [  57] = { PZI = 10, -- PoiZoneIndex "Deshaan"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 40, 41, 42 },
             },
------------
    [  58] = { PZI = 11, -- PoiZoneIndex "Malabal Tor"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 38, 39, 40 },
             },
------------
    [  92] = { PZI = 14, -- PoiZoneIndex "Bangkorai"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 37, 38, 39 },
             },
------------
    [ 101] = { PZI = 15, -- PoiZoneIndex "Eastmarch"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 38, 39, 40 },
             },
------------
    [ 103] = { PZI = 16, -- PoiZoneIndex "The Rift"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 39, 40, 41 },
             },
------------
    [ 104] = { PZI = 17, -- PoiZoneIndex "Alik'r Desert"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 36, 37, 38 },
             },
------------
    [ 108] = { PZI = 18, -- PoiZoneIndex "Greenshade"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 29, 30, 31 },
             },
------------
    [ 117] = { PZI = 19, -- PoiZoneIndex "Shadowfen"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 41, 42, 43 },
             },
------------
    [ 181] = { PZI = 38, -- PoiZoneIndex "Cyrodiil"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 58, 59, 60, 61, 62, 63, 64, 65, 66, 106 },
             },
------------
    [ 381] = { PZI = 179, -- PoiZoneIndex "Auridon"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 37, 38, 39 },
             },
------------
    [ 382] = { PZI = 180, -- PoiZoneIndex "Reaper's March"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 24, 25, 26 },
             },
------------
    [ 383] = { PZI = 181, -- PoiZoneIndex "Grahtwood"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_DARK_ANCHOR,
               POI = { 26, 27, 28 },
             },
------------
    [1011] = { PZI = 617, -- PoiZoneIndex "Summerset"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_GEYSER,
               POI = { 44, 46, 49, 51, 52, 58 },
             },
------------
    [1160] = { PZI = 744, -- PoiZoneIndex "Western Skyrim"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_HARROWSTORM,
               POI = { 29, 30, 31, 32, 33, 34 },
               Replace = { ["RU"] = "ьный " },
             },
------------
    [1161] = { PZI = 745, -- PoiZoneIndex "Blackreach: Greymoor Caverns"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_HARROWSTORM,
               POI = { 18, 19, 20, 21 },
               Replace = { ["RU"] = "ьный " },
             },
------------
    [1207] = { PZI = 784, -- PoiZoneIndex "The Reach"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_HARROWSTORM,
               POI = { 8, 9, 13, 14 },
               Replace = { ["RU"] = "ьный " },
             },
------------
    [1318] = { PZI = 884, -- PoiZoneIndex "High Isle"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_FISSURE,
               POI = { 41, 42, 43, 44, 45, 46, 47 },
               Replace = { ["RU"] = "ический " },
             },
------------
    [1383] = { PZI = 930, -- PoiZoneIndex "Galen"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_FISSURE,
               POI = { 11, 12, 13, 14, 15 },
               Replace = { ["RU"] = "ический " },
             },
------------
    [1443] = { PZI = 981, -- PoiZoneIndex "West Weald"
--               ZoneName = "",
               WEContext = WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST,
               EventType = WORLD_EVENT_TYPE_MIRRORMOOR,
               POI = { 60, 62, 63, 64 },
               Replace = { ["RU"] = "альной " },
             },
------------
  }, -- POIEvents array
} -- WorldEvents array
local isPlayerChangedZone = false -- true if player change location
--=========================================================================
--================= World events code Section =============================
--=========================================================================
local function CWE_Iterator(array)
  local i = 0 -- iterator
  local iterFunc =
    function ()
      i = i + 1
      if SortedWorldEventsIndex[i] == nil then
        return nil, nil
      else
        return SortedWorldEventsIndex[i], array[ SortedWorldEventsIndex[i] ]
      end
    end
  return iterFunc
end

local function UpdateWorldEventsIndex()
  local tinsert = table.insert
  SortedWorldEventsIndex = {}
  for ind in pairs(CurrentWorldEvents) do tinsert(SortedWorldEventsIndex, ind) end
  if #SortedWorldEventsIndex > 0 then
    table.sort(SortedWorldEventsIndex,
               function(A, B)
                 return CurrentWorldEvents[A].EndTS < CurrentWorldEvents[B].EndTS
               end)
  end
end

local function GetDistanceFromPlayer(uTag)
  local PlayerX, PlayerY, PlayerZ = 0, 0, 0
  local UnitX, UnitY, UnitZ = 0, 0, 0
  local UnitZoneId = 0
  UnitZoneId, PlayerX, PlayerY, PlayerZ = GetUnitWorldPosition("player")
  UnitZoneId, UnitX, UnitY, UnitZ = GetUnitWorldPosition(uTag)
  local X = UnitX - PlayerX
  local Y = UnitY - PlayerY
  local Z = UnitZ - PlayerZ
  local D = math.floor(math.sqrt(X*X + Y*Y + Z*Z) / 100)
---- local D = math.floor(zo_distance3D(UnitX, UnitY, UnitZ, PlayerX, PlayerY, PlayerZ) / 100)
  return D
end

--[[
local function UpdateAverageTimeBetweenUNIT(WEInstanceId)
--  local WE = WorldEvents
  local unitData = CurrentWorldEvents[WEInstanceId]
  if unitData then
    local old = unitData.OldEndTS or 0
    local curr = unitData.EndTS or 0
    if old > 0 then CurrentWorldEvents[WEInstanceId].AverageTimeBetweenUNIT = curr - old
    else CurrentWorldEvents[WEInstanceId].AverageTimeBetweenUNIT = 0
    end
  end
end -- UpdateAverageTimeBetweenUNIT end
--]]

local function UpdateAverageTimeBetweenPOI()
  local WE = WorldEvents
  local countEndedWE = 0 -- how many WE's have completed right now
  local avrTime = 0
  for i = 1, #SortedWorldEventsIndex do
    local ind1 = SortedWorldEventsIndex[i]
    local ind2 = SortedWorldEventsIndex[i + 1] or SortedWorldEventsIndex[1]
    local ets1 = CurrentWorldEvents[ind1].EndTS
    local ets2 = CurrentWorldEvents[ind2].EndTS
    if (ets1 > 9999) and (ets2 > 9999) then
      countEndedWE = countEndedWE + 1
      if ets1 < ets2 then
        avrTime = avrTime + (ets2 - ets1)
      else
        avrTime = avrTime + math.floor( (ets1 - ets2) / (#SortedWorldEventsIndex - 1) )
      end
    end
  end
  if countEndedWE > 0 then
    WE.AverageTimeBetweenPOI = math.floor(avrTime / countEndedWE) -- average time between POIs
  end
end -- UpdateAverageTimeBetweenPOI end

local function ActivateWorldEventDataUNIT(WEInstanceId, WEUnitTag)
  local WE = WorldEvents
  local CWE = CurrentWorldEvents[WEInstanceId]
  local WEunits = GetNumWorldEventInstanceUnits(WEInstanceId)
  if WEunits > 0 then
    if not CWE then
      --- unknown UNIT detected ---
      CurrentWorldEvents[WEInstanceId] = {}
      CWE = CurrentWorldEvents[WEInstanceId]
      CWE.EndTS = 0
    end
    local uTag = WEUnitTag or GetWorldEventInstanceUnitTag(WEInstanceId, 1) -- usually only 1 unit per event
    local curHP, maxHP, emaxHP = GetUnitPower(uTag, COMBAT_MECHANIC_FLAGS_HEALTH)
--
    local unitName = ""
    local nameBuff, _, _, _, _, _, _, _, _, _, abilityID = GetUnitBuffInfo(uTag, 1) -- 1st buff is a type of unit
    if WE.UNITBuffs[abilityID] then unitName = nameBuff
    else unitName = GetUnitName(uTag)
    end
--
    CWE.isActive = true
    CWE.UnitTag = uTag
    CWE.Name = zo_strformat( SI_COMPANION_NAME_FORMATTER, unitName )
    CWE.CurHP = curHP
    CWE.MaxHP = emaxHP
--    CWE.PinType = GetWorldEventInstanceUnitPinType(WEInstanceId, uTag)
--    CWE.PinIcon = pinIcon
--    CWE.EndTS = 0
  end
end -- ActivateWorldEventDataUNIT end

local function DeactivateWorldEventDataUNIT(WEInstanceId, WEUnitTag)
--  local WE = WorldEvents
--  local currZoneId = WE.CurrentZoneId
  local CWE = CurrentWorldEvents[WEInstanceId]
  if CWE then
    CWE.isActive = false
    CWE.EndTS = GetTimeStamp()
--    CWE.PinType = GetWorldEventInstanceUnitPinType(WEInstanceId, WEUnitTag)
--    CWE.PinIcon = pinIcon
  end
end -- DeactivateWorldEventDataUNIT end

local function ActivateWorldEventDataPOI(WEInstanceId)
  local WE = WorldEvents
  local zoneInd, poiInd = GetWorldEventPOIInfo(WEInstanceId)
  local CWE = CurrentWorldEvents[poiInd]
  if not CWE then
    --- unknown POI detected ---
    CurrentWorldEvents[poiInd] = {}
    CWE = CurrentWorldEvents[poiInd]
    local poiName = GetPOIInfo(zoneInd, poiInd)
    CWE.Name = zo_strformat(SI_WORLD_MAP_LOCATION_NAME, poiName)
    CWE.EndTS = poiInd
  end
---
  local mapX, mapZ, pinType, pinIcon = GetPOIMapInfo(zoneInd, poiInd)
  pinIcon = "|t24:24:" .. pinIcon .. "|t"
  CWE.PinType = pinType
  CWE.PinIcon = pinIcon
  CWE.isActive = true
---
  if isPlayerChangedZone or (WE.CurrentActivePOI.POI ~= poiInd) then
    WE.CurrentActivePOI.POI = poiInd
    WE.CurrentActivePOI.StartTS = GetTimeStamp()
  end
end -- ActivateWorldEventDataPOI end

local function DeactivateWorldEventDataPOI()
  local WE = WorldEvents
  local poiInd = WE.CurrentActivePOI.POI
  local CWE = CurrentWorldEvents[poiInd]
  if CWE then
    local TS = GetTimeStamp()
    CWE.isActive = false
    CWE.ActTime = 0
    if (TS - WE.CurrentActivePOI.StartTS) > 10 then -- protection against "false completing" of the event
      CWE.EndTS = TS
      CWE.ActTime = TS - WE.CurrentActivePOI.StartTS
      local currZoneId = WE.CurrentZoneId
      local poiZI = WE.POIEvents[currZoneId].PZI
      local mapX, mapZ, pinType, pinIcon = GetPOIMapInfo(poiZI, poiInd)
      pinIcon = "|t24:24:" .. pinIcon .. "|t"
      CWE.PinType = pinType
      CWE.PinIcon = pinIcon
    end
  end
---
  WE.CurrentActivePOI.POI = 0
  WE.CurrentActivePOI.StartTS = 0
end -- DeactivateWorldEventDataPOI end

local function UpdateCurrentWorldEvents(WEContext, WEAction, WEInstanceId)
  if WEAction == "RELOAD" then
   --- collect info about all current World Events ---
    WEInstanceId = GetNextWorldEventInstanceId(nil)
    while WEInstanceId do
      if WEContext == WORLD_EVENT_LOCATION_CONTEXT_UNIT then
        ActivateWorldEventDataUNIT(WEInstanceId)
      else -- POI
        ActivateWorldEventDataPOI(WEInstanceId)
      end
      WEInstanceId = GetNextWorldEventInstanceId( WEInstanceId )
    end
--
  elseif WEAction == "ACT" then
   --- activation of a single event ---
    if WEContext == WORLD_EVENT_LOCATION_CONTEXT_UNIT then
      ActivateWorldEventDataUNIT(WEInstanceId, WEUnitTag)
    else -- POI
      ActivateWorldEventDataPOI(WEInstanceId)
    end
--
  elseif WEAction == "DEACT" then
   --- deactivation of a single event ---
    if WEContext == WORLD_EVENT_LOCATION_CONTEXT_UNIT then
      DeactivateWorldEventDataUNIT(WEInstanceId, WEUnitTag)
    else -- POI
      DeactivateWorldEventDataPOI()
    end
  end
--
  UpdateWorldEventsIndex()
--  if WEContext == WORLD_EVENT_LOCATION_CONTEXT_UNIT then
---    UpdateAverageTimeBetweenUNIT(WEInstanceId)
--  else -- POI
    UpdateAverageTimeBetweenPOI()
--  end
end -- UpdateCurrentWorldEvents end

local function ReloadCurrentZoneWE()
  local WE = WorldEvents
  local currZoneId = GetUnitWorldPosition("player")
--  local currZoneName = GetUnitZone("player")
  if WE.CurrentZoneId ~= currZoneId then -- the player has changed location or just log in the game
   --- full initialization of the WE list in the location ---
    CurrentWorldEvents = {}
    WE.AverageTimeBetweenPOI = 0
    WE.CurrentZoneId = currZoneId
    isPlayerChangedZone = true
    if WE.POIEvents[currZoneId] then -- it's a POI-WE location
      local zoneWE = WE.POIEvents[currZoneId]
      local poiZI = zoneWE.PZI
      local context = zoneWE.WEContext
--      if zoneWE.ZoneName ~= currZoneName then zoneWE.ZoneName = currZoneName end
      for i = 1, #zoneWE.POI do
        local poiInd = zoneWE.POI[i]
        CurrentWorldEvents[poiInd] = {}
        local CWE = CurrentWorldEvents[poiInd]
        CWE.isActive = false
        local poiName = GetPOIInfo(poiZI, poiInd)
        poiName = zo_strformat(SI_WORLD_MAP_LOCATION_NAME, poiName)
        CWE.Name = poiName
        if zoneWE.Replace and zoneWE.Replace[WPamA.i18n.Lng] then
          CWE.Name = poiName:gsub(zoneWE.Replace[WPamA.i18n.Lng], ".")
        end
--        CWE.EndTS = 0
--        CWE.ToolTip = ""
        CWE.EndTS = poiInd
        CWE.ActTime = 0
        local mapX, mapZ, pinType, pinIcon = GetPOIMapInfo(poiZI, poiInd)
        pinIcon = "|t24:24:" .. pinIcon .. "|t"
        CWE.PinType = pinType
        CWE.PinIcon = pinIcon
      end
      UpdateCurrentWorldEvents(context, "RELOAD")
--
    elseif WE.UNITEvents[currZoneId] then -- it's a Unit-WE location
      local zoneWE = WE.UNITEvents[currZoneId]
      local context = zoneWE.WEContext
--      if zoneWE.ZoneName ~= currZoneName then zoneWE.ZoneName = currZoneName end
      for i = 1, #zoneWE.UNIT do
        local unitInd = zoneWE.UNIT[i]
        CurrentWorldEvents[unitInd] = {}
        local CWE = CurrentWorldEvents[unitInd]
        CWE.isActive = false
        CWE.UnitTag = ""
        CWE.Name = ""
        CWE.EndTS = 0
        CWE.CurHP = 0
        CWE.MaxHP = 0
--        CWE.PinType = 0
--        CWE.PinIcon = ""
      end
      UpdateCurrentWorldEvents(context, "RELOAD")
--
    else -- it's a location with an unknown WE type
      CurrentWorldEvents[1] = { isActive = false, EndTS = 0, PinType = 0, PinIcon = "", Name = WPamA.i18n.NoWorldEventsHere }
      WE.AverageTimeBetweenPOI = 0
      UpdateWorldEventsIndex()
    end
-------
  else -- the player stayed at the same location
    isPlayerChangedZone = false
    if WE.POIEvents[currZoneId] then -- it's a POI-WE location
      local zoneWE = WE.POIEvents[currZoneId]
      local context = zoneWE.WEContext
      for i = 1, #zoneWE.POI do
        local poiInd = zoneWE.POI[i]
        CurrentWorldEvents[poiInd].isActive = false
      end
      UpdateCurrentWorldEvents(context, "RELOAD")
--
    elseif WE.UNITEvents[currZoneId] then -- it's a Unit-WE location
      local zoneWE = WE.UNITEvents[currZoneId]
      local context = zoneWE.WEContext
      for i = 1, #zoneWE.UNIT do
        local unitInd = zoneWE.UNIT[i]
        CurrentWorldEvents[unitInd].isActive = false
      end
      UpdateCurrentWorldEvents(context, "RELOAD")
--
    else -- it's a location with an unknown WE type
      CurrentWorldEvents[1] = { isActive = false, EndTS = 0, PinType = 0, PinIcon = "", Name = WPamA.i18n.NoWorldEventsHere }
      WE.AverageTimeBetweenPOI = 0
      UpdateWorldEventsIndex()
    end
  end -- a location has been changed or not
-------
  WPamA:UpdCharLoginData(isPlayerChangedZone) -- hirelings mail update
-------
  local m = WPamA.SV_Main.ShowMode
  local Modes = { [5] = true, [38] = true }
  if Modes[m] then WPamA:UpdWindowInfo() end
end -- ReloadCurrentZoneWE end

function WPamA.OnPlayerActiveWE(event, ...)
  local WE = WorldEvents
  if event == EVENT_PLAYER_DEACTIVATED then
    WE.isPlayerActive = false
    WPamA.CurChar.PlayedTime = GetSecondsPlayed()
  elseif event == EVENT_PLAYER_ACTIVATED then
    ReloadCurrentZoneWE()
    WE.isPlayerActive = true
  end -- events
end -- OnPlayerActiveWE end

function WPamA.OnWorldEventsCalled(eventCode, WEInstanceId, unitTag, ...)
  if not WorldEvents.isPlayerActive then return end
  local WELocationContext = GetWorldEventLocationContext(WEInstanceId)
  -- WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST | WORLD_EVENT_LOCATION_CONTEXT_UNIT | WORLD_EVENT_LOCATION_CONTEXT_NONE

  --======================= Unknown events ===========================
  if WELocationContext == WORLD_EVENT_LOCATION_CONTEXT_NONE then
    d("=-=- Unknown WE detected id:" .. WEInstanceId .. "-=-=")

  --====================== POI-based events ==========================
  elseif WELocationContext == WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST then
    if eventCode == EVENT_WORLD_EVENT_ACTIVATED then
    -- EVENT_WORLD_EVENT_ACTIVATED (worldEventInstanceId)
      UpdateCurrentWorldEvents(WELocationContext, "ACT", WEInstanceId)
    elseif eventCode == EVENT_WORLD_EVENT_DEACTIVATED then
     -- EVENT_WORLD_EVENT_DEACTIVATED (worldEventInstanceId)
      UpdateCurrentWorldEvents(WELocationContext, "DEACT", WEInstanceId)
    end

  --====================== UNIT-based events =========================
  elseif WELocationContext == WORLD_EVENT_LOCATION_CONTEXT_UNIT then
    if eventCode == EVENT_WORLD_EVENT_UNIT_CREATED then
     -- EVENT_WORLD_EVENT_UNIT_CREATED (worldEventInstanceId, unitTag)
      ActivateWorldEventDataUNIT(WEInstanceId, unitTag)
    elseif eventCode == EVENT_WORLD_EVENT_UNIT_DESTROYED then
     -- EVENT_WORLD_EVENT_UNIT_DESTROYED (worldEventInstanceId, unitTag)
      DeactivateWorldEventDataUNIT(WEInstanceId, unitTag)
--    elseif eventCode == EVENT_WORLD_EVENT_UNIT_CHANGED_PIN_TYPE then
     -- EVENT_WORLD_EVENT_UNIT_CHANGED_PIN_TYPE (worldEventInstanceId, unitTag, oldPinType, newPinType)
    end
  end -- Location's Context
--
  local m = WPamA.SV_Main.ShowMode
  if m == 38 then WPamA:UpdWindowInfo() end
end -- OnWorldEventsCalled end

function WPamA:GetWEModeColumnNames(columnType)
  local WE = WorldEvents
  local czi = WE.CurrentZoneId
  local context = WORLD_EVENT_LOCATION_CONTEXT_NONE
  if WE.POIEvents[czi] then context = WE.POIEvents[czi].WEContext end
  if WE.UNITEvents[czi] then context = WE.UNITEvents[czi].WEContext end
--
  if columnType == "A" then
    if context == WORLD_EVENT_LOCATION_CONTEXT_UNIT then
      return "|t24:24:esoui/art/tutorial/achievements_indexicon_exploration_up.dds|t",
             GetString(SI_NOTIFICATIONTYPE19)
    else -- POI and None
      return "|t24:24:esoui/art/tutorial/achievements_indexicon_darkanchors_up.dds|t",
             GetString(SI_NOTIFICATIONTYPE19)
    end
  elseif columnType == "B" then
    if context == WORLD_EVENT_LOCATION_CONTEXT_UNIT then
      self.i18n.ToolTip[112] = self.i18n.ToolTip[118]
      self.i18n.ToolTip[113] = self.i18n.ToolTip[119]
      self.i18n.ToolTip[114] = self.i18n.ToolTip[120]
      return "HP % /" ..
             "|t28:28:esoui/art/progression/progression_crafting_delevel_up.dds|t",
             self.i18n.WEDistance,
             "|t26:26:esoui/art/mounts/ridingskill_ready.dds|t"
    else -- POI and None
      self.i18n.ToolTip[112] = self.i18n.ToolTip[115]
      self.i18n.ToolTip[113] = self.i18n.ToolTip[116]
      self.i18n.ToolTip[114] = self.i18n.ToolTip[117]
      return "|t24:24:esoui/art/progression/progression_tabicon_weapons_active.dds|t" .. " /" ..
             "|t28:28:esoui/art/progression/progression_crafting_delevel_up.dds|t",
             "|t24:24:esoui/art/progression/progression_tabicon_weapons_active.dds|t" ..
             "|t26:26:esoui/art/tutorial/timer_icon.dds|t",
             "|t26:26:esoui/art/mounts/ridingskill_ready.dds|t"
    end
  end
--
  return "", "", ""
end -- GetWEModeColumnNames end

function WPamA:UpdWindowModeWorldEvents()
  self.Mode67PeriodUpd = 0
  local unitMaxHP = 0 -- a dummy var instead of _ var
  local TS = GetTimeStamp()
  local f = self.SV_Main.LFGRndAvlFrmt
  local iconVet = "|t24:24:esoui/art/lfg/lfg_veterandungeon_up.dds|t"
  local WE = WorldEvents
  local sts = WE.CurrentActivePOI.StartTS
  local czi = WE.CurrentZoneId
  local context = WORLD_EVENT_LOCATION_CONTEXT_NONE
  local deltaResp = 0
  if WE.POIEvents[czi] then
    context = WE.POIEvents[czi].WEContext
    deltaResp = WE.POIEvents[czi].RespTimeDelta or 35
  end
  if WE.UNITEvents[czi] then
    context = WE.UNITEvents[czi].WEContext
    deltaResp = WE.UNITEvents[czi].RespTimeDelta or 0
  end
--
  local RowCnt = #SortedWorldEventsIndex
  for i = RowCnt + 1, self.Consts.RowCnt do
    self.ctrlRows[i].Row:SetHidden(true)
  end
  self:UI_UpdMainWindowSize(38, RowCnt)
  self:UI_UpdMainWindowHdr()
--
  for i = 1, RowCnt do
    local CWE = CurrentWorldEvents[ SortedWorldEventsIndex[i] ]
    local r = self.ctrlRows[i]
    local txt = ""
    --========================= Units ==============================
    if context == WORLD_EVENT_LOCATION_CONTEXT_UNIT then
      r.BG:SetHidden(true)
      local unitPos = WE.UNITEvents[czi].UnitPos[ SortedWorldEventsIndex[i] ] or ""
      r.Lvl:SetText(unitPos)
      r.Char:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
      r.Char:SetColor(self:GetColor(self.Colors.LabelLvl))
      txt = CWE.Name
      if CWE.MaxHP > 15000000 then txt = txt .. " " .. iconVet end
      self:SetScaledText(r.Char, txt)
--
      local unitDist = 99999
      if CWE.isActive then unitDist = GetDistanceFromPlayer(CWE.UnitTag) end
--
      r.B[1]:SetColor(self:GetColor(self.Colors.LabelLvl))
      if CWE.isActive then
        CWE.CurHP, unitMaxHP, CWE.MaxHP = GetUnitPower(CWE.UnitTag, COMBAT_MECHANIC_FLAGS_HEALTH)
        local percHP = math.floor(100 * CWE.CurHP / CWE.MaxHP) -- / 100
        txt = percHP .. " %"
        if unitDist > 299 then
          r.B[1]:SetColor(self:GetColor(self.Colors.DungStNA))
        end
        if self.Mode67PeriodUpd > 0 then self.Mode67PeriodUpd = 0 end -- let time tick every second
--
      elseif CWE.EndTS > 9999 then
        txt = "|t24:24:esoui/art/progression/progression_crafting_delevel_up.dds|t"
        if f == 1 then
          txt = txt .. self:DifTSToStr(TS - CWE.EndTS, true, 0)
        elseif f == 2 then
          txt = txt .. self:TimestampToStr(CWE.EndTS, 6, true)
        else
          txt = txt .. self:TimestampToStr(CWE.EndTS, 7, true)
        end
      else -- EndTS not exist
        r.B[1]:SetColor(self:GetColor(self.Colors.DungStNA))
        txt = self.i18n.DungStNA
      end
      self:SetScaledText(r.B[1], txt)
--
      r.B[2]:SetColor(self:GetColor(self.Colors.LabelLvl))
      if CWE.isActive then
        txt = unitDist .. " m"
--[[
      elseif CWE.ActTime > 0 then
        txt = ZO_FormatTime( CWE.ActTime,
              TIME_FORMAT_STYLE_DESCRIPTIVE_MINIMAL, TIME_FORMAT_PRECISION_TWENTY_FOUR_HOUR):gsub("m.-$","m")
--]]
      else
        r.B[2]:SetColor(self:GetColor(self.Colors.DungStNA))
        txt = "---- m"
--        txt = self.i18n.DungStNA
      end
      self:SetScaledText(r.B[2], txt)
--
      r.B[3]:SetColor(self:GetColor(self.Colors.LabelLvl))
      if CWE.isActive then
        txt = " "
      elseif CWE.EndTS > 9999 then
        local nextTime = CWE.EndTS + deltaResp - TS
        if nextTime < 1 then
          txt = GetString(SI_GAMEPAD_GENERIC_WAITING_TEXT)
        else
          txt = ""
          if f == 1 then
            txt = txt .. self:DifTSToStr(nextTime, true, 0)
          elseif f == 2 then
            txt = txt .. self:TimestampToStr(TS + nextTime, 6, true)
          else
            txt = txt .. self:TimestampToStr(TS + nextTime, 7, true)
          end
        end
      else -- EndTS not exist
        r.B[3]:SetColor(self:GetColor(self.Colors.DungStNA))
        txt = self.i18n.DungStNA
      end
      self:SetScaledText(r.B[3], txt)

    --========================== POI ===============================
    elseif context == WORLD_EVENT_LOCATION_CONTEXT_POINT_OF_INTEREST then
      r.BG:SetHidden( not CWE.isActive )
      if CWE.PinType ~= MAP_PIN_TYPE_POI_COMPLETE then
        r.Lvl:SetText(CWE.PinIcon)
      else
        r.Lvl:SetText(" ")
      end
      r.Char:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
      r.Char:SetColor(self:GetColor(self.Colors.LabelLvl))
      self:SetScaledText(r.Char, CWE.Name)
--
      r.B[1]:SetColor(self:GetColor(self.Colors.LabelLvl))
      if CWE.isActive then
        if sts > 0 then
          txt = "|t24:24:esoui/art/progression/progression_tabicon_weapons_active.dds|t" ..
                self:DifTSToStr(TS - WE.CurrentActivePOI.StartTS, true, 0, true)
        else
          txt = " "
        end
      elseif CWE.EndTS > 9999 then
        txt = "|t24:24:esoui/art/progression/progression_crafting_delevel_up.dds|t"
        if f == 1 then
          txt = txt .. self:DifTSToStr(TS - CWE.EndTS, true, 0)
        elseif f == 2 then
          txt = txt .. self:TimestampToStr(CWE.EndTS, 6, true)
        else
          txt = txt .. self:TimestampToStr(CWE.EndTS, 7, true)
        end
      else -- EndTS not exist
        r.B[1]:SetColor(self:GetColor(self.Colors.DungStNA))
        txt = self.i18n.DungStNA
      end
      self:SetScaledText(r.B[1], txt)
--
      r.B[2]:SetColor(self:GetColor(self.Colors.LabelLvl))
      if CWE.isActive then
        txt = " "
      elseif CWE.ActTime > 0 then
        txt = ZO_FormatTime( CWE.ActTime,
              TIME_FORMAT_STYLE_DESCRIPTIVE_MINIMAL, TIME_FORMAT_PRECISION_TWENTY_FOUR_HOUR):gsub("m.-$","m")
      else
        r.B[2]:SetColor(self:GetColor(self.Colors.DungStNA))
        txt = self.i18n.DungStNA
      end
      self:SetScaledText(r.B[2], txt)
--
      r.B[3]:SetColor(self:GetColor(self.Colors.LabelLvl))
      if CWE.isActive then
        txt = " "
      elseif CWE.EndTS > 9999 then
        if WE.AverageTimeBetweenPOI > 0 then
          local deltaTime = (#SortedWorldEventsIndex - 1) * WE.AverageTimeBetweenPOI
          local nextTime = CWE.EndTS + deltaTime + deltaResp - TS
          if nextTime < 1 then
            txt = GetString(SI_GAMEPAD_GENERIC_WAITING_TEXT)
          else
            txt = ""
            if f == 1 then
              txt = txt .. self:DifTSToStr(nextTime, true, 0)
            elseif f == 2 then
              txt = txt .. self:TimestampToStr(TS + nextTime, 6, true)
            else
              txt = txt .. self:TimestampToStr(TS + nextTime, 7, true)
            end
          end
        else
          r.B[3]:SetColor(self:GetColor(self.Colors.DungStNA))
          txt = self.i18n.WECalculating
        end
      else -- EndTS not exist
        r.B[3]:SetColor(self:GetColor(self.Colors.DungStNA))
        txt = self.i18n.DungStNA
      end
      self:SetScaledText(r.B[3], txt)

    --========================= None ===============================
    else
      r.BG:SetHidden(true)
      r.Lvl:SetText(" ")
      r.Char:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
      r.Char:SetColor(self:GetColor(self.Colors.LabelLvl))
      self:SetScaledText(r.Char, CWE.Name)
      self:SetScaledText(r.B[1], " ")
      self:SetScaledText(r.B[2], " ")
      self:SetScaledText(r.B[3], " ")
    end
--
    r.Row:SetHidden(false)
  end
---- esoui/art/mappins/dragon_fly_damaged.dds
---- esoui/art/mappins/dragon_fly.dds
end -- UpdWindowModeWorldEvents end
